#!/usr/bin/perl

#
#	Variance is sum(x - xbar)**2 / n
#

my @data = (3, 20, 14, 7, 8);
my $answer = variance(@data);

print("The variance is $answer\n");

#
#	If you're passing an array to a subroutine,
#	you probably do *not* want to make a copy of it into
#	a local variable. This is one place where @_ is useful.
#
sub variance
{
	my $sum = 0;
	my $n;
	my $average = 0;
	my $result = 0;
	
	$n = scalar(@_);
	
	if ($n > 0)
	{
		foreach my $item (@_)
		{
			$sum += $item;
		}
		$average = $sum / $n;
		
		foreach my $item (@_)
		{
			$result = $result + ($item - $average) ** 2;
		}
		$result = $result / $n;
	}
	return $result;
	
}
